#!/bin/sh

if test -z $1; then
	echo "Need a version number as first argument"
	exit 1
fi;

echo "Creating qlinecontrol-$1 release tarball, stay tuned"

echo "=> Compiling translations... "
lrelease qlinecontrol.pro || exit 1


echo "---"
echo "=> Creating makefiles... "
qmake -makefile qlinecontrol.pro || exit 1


echo "---"
echo "=> Cleaning project... "
#make clean || exit 1


echo "---"
echo "=> Compiling qlinecontrol... "
make all || exit 1


echo "---"
echo "Installing into dist dir... "
make install || exit 1


echo "---"
echo "=> Creating distribution tarball... "
tar -c -j -C ./dist -f "qlinecontrol-$1-bin.tar.bz2" . || exit 1


echo "---"
echo "=> Cleaning up... "
rm -rf ./dist
make distclean
