/***************************************************************************
                             client main window
                             -------------------
    begin                : Thu Dec 01 16:26 CET 2005
    copyright            : (C) 2005 by Stefan Gehn
    email                : metz \AT\ gehn \DOT\ net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LCMAINWINDOW_H
#define LCMAINWINDOW_H

class LcpIO;
class QAction;
class QMenu;
class QLabel;
class LCMainWidget;
class TrayIcon;
class QActionGroup;
class LcpLine;
class LCSettingsDlg;
class LCMiniDisplay;

#include <qmainwindow.h>

class LCMainWindow : public QMainWindow
{
Q_OBJECT
public:
	LCMainWindow();
	~LCMainWindow();

public slots:
   void toggleVisibility();

protected:
	void setupActions();
	void setupMenubar();
	void setupToolbar();
	void setupStatusbar();
	void setupTray();
	void updateTrayIcon();

	void closeEvent(QCloseEvent *e);

protected slots:
	void slotInit();
	void slotPrepareTrayMenu();
	void slotAllLinesReceived(QList<LcpLine *> *lines);
	void slotSelectedLineChanged(LcpLine *);
	void slotClientStatus(int clientStatus);
	void slotLineStatus(int lineStatus);
	void slotAuthFailed();
	void slotConnect();
	void slotTrayClosed();
	void slotAbout();
	void slotAboutQt();
	void slotLoadSettings();

private:
	int mCStatus, mLStatus; // last known client-/line-state, needed for tray-icon
	LCMainWidget *mMainWidget;
	LCMiniDisplay *mMiniDisp;
	LcpIO *mIO;
	QMenu *mSettingsMenu, *mTrayMenu, *mLinesMenu;
	QAction *mQuitAction, *mHideShowAction,
		*mConnectAction, *mDisconnectAction,
		*mOnlineAction, *mOfflineAction,
		*mLockAction,
		*mCfgAction;
	QActionGroup *mLineSelectorAction;
	TrayIcon *mTray;
	LCSettingsDlg *mSettingsDlg;
};

#endif // LCMAINWINDOW_H
