/***************************************************************************
                            mini window contents
                             -------------------
    begin                : Thu Dec 01 22:13 CET 2005
    copyright            : (C) 2005 by Stefan Gehn
    email                : metz \AT\ gehn \DOT\ net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LCMINIWIDGET_H
#define LCMINIWIDGET_H

#include "lcpio/lcp3.h"
#include "lcsettings.h"

#include <qframe.h>
#include <qpoint.h>

class LcpLine;
class QProgressBar;
class QLabel;
class QMouseEvent;

class LCMiniDisplay : public QFrame
{
Q_OBJECT
public:
	LCMiniDisplay();
	~LCMiniDisplay();
	
public slots:
	void updateLineInfo(t_lcp3_info_tput, double clientCost, double lineCost);
	void updateSelectedLine(LcpLine *);
	void updateClientStatus(int status);
	void updateLineStatus(int status);
	void loadSettings();

protected:
	virtual void mousePressEvent ( QMouseEvent * e );
	virtual void mouseMoveEvent ( QMouseEvent * e );
	virtual void mouseReleaseEvent ( QMouseEvent * e );

private slots:
   void updateVisibility();
   
private:
	void setupUi();
   void resetView();
   
private:
   LCSettings::ShowMode mShowMode;
	bool bMove;
	bool bClientIsOnline, bLineIsUp;
	QPoint mMoveOrigin;
	QProgressBar *pbDown, *pbUp;
	QLabel *lbDownSpeed, *lbUpSpeed;
	QLabel *lbDownTotal, *lbUpTotal;
	QLabel *lbLineTime;
};

#endif // LCMINIWIDGET_H

