/***************************************************************************
                               client settings
                             -------------------
    begin                : Thu Dec 01 18:08 CET 2005
    copyright            : (C) 2005 by Stefan Gehn
    email                : metz \AT\ gehn \DOT\ net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LCSETTINGS_H
#define LCSETTINGS_H

#include <qobject.h>
#include <qpoint.h>

class QSettings;
class QMainWindow;

class LCSettings : public QObject
{
Q_OBJECT
	
public:
	static LCSettings *self(); // We are a singleton and this is the accessor
	~LCSettings();
	
	void sync();
	
	// Server connection settings
	QString getServerHost() const;
	void setServerHost(const QString &);
	
	int getServerPort() const;
	void setServerPort(int);
	
	bool getUseAuth() const;
	void setUseAuth(bool);
	
	QString getAuthName() const;
	void setAuthName(const QString &);
	
	QString getAuthPass() const;
	void setAuthPass(const QString &);

	bool getStoreAuthPass() const;
	void setStoreAuthPass(bool);


	// Client behaviour settings
	bool getAutoConnect() const;
	void setAutoConnect(bool);
	
	bool getAutoOnline() const;
	void setAutoOnline(bool);


	// Look and feel settings
	bool getRememberWindowState() const; //! Remember window state (minimized)
	void setRememberWindowState(bool);

	bool getUseTray() const; //! Dock to system tray
	void setUseTray(bool);


	// minidisplay
	int getMiniDispOpacity() const;
	void setMiniDispOpacity(int);
	
	enum ShowMode { Never = 0, Always, ServerOnline, ClientAndServerOnline };
	ShowMode getMiniDispShowMode() const;
	void setMiniDispShowMode(ShowMode);
	
	int getMiniDispWidth() const;
	void setMiniDispWidth(int);

	QPoint getMiniDispPos() const;
	void setMiniDispPos(QPoint val);
	
	bool getMiniDispShowLineTime() const;
	void setMiniDispShowLineTime(bool);

	// general mainwindow
	void saveWindowSettings(const QMainWindow *w);
	void loadWindowSettings(QMainWindow *w);

signals:
	void settingsChanged();
	
private:
	LCSettings(QObject *parent);
	static LCSettings *sSelf;
	QSettings *s;
};

#endif // LCSETTINGS_H

