/***************************************************************************
                      dialog with standard buttons at the bottom
                             -------------------
    begin                : Sat Jul 30 19:32 CET 2005
    copyright            : (C) 2005 by Stefan Gehn
    email                : metz \AT\ gehn \DOT\ net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QSDIALOG_H
#define QSDIALOG_H

#include <qdialog.h>

class QLayout;
class QGridLayout;

class QSDialog: public QDialog
{
Q_OBJECT

public:
	enum Button
	{
		OkButton = 0x01
		, CancelButton = 0x02
		, ApplyButton = 0x04
		, HelpButton = 0x08
	};
	
	typedef int Buttons;

	QSDialog(QWidget *parent, const QString &title, QSDialog::Buttons buttons,
		QSDialog::Button defaultButton);
		
	void setMainWidget(QWidget *widget);

signals:
	void okClicked();
	void cancelClicked();
	void applyClicked();
	void helpClicked();

private:
	QLayout *createButtons(QSDialog::Buttons buttons, QSDialog::Button def);
	
	QGridLayout *mLayout;
	QWidget *mMainWidget;
}; // END class QSDialog

#endif // QSDIALOG_H
