/***************************************************************************
                              tree list widget
                             -------------------
    begin                : Sat Jul 30 19:32 CET 2005
    copyright            : (C) 2005 by Stefan Gehn
    email                : metz \AT\ gehn \DOT\ net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QTREELISTWIDGET_H
#define QTREELISTWIDGET_H

#include <qwidget.h>
#include <qframe.h>
#include <qmap.h>
#include <qicon.h>

class QTreeWidget;
class QTreeWidgetItem;
class QSplitter;
class QLabel;
class QStackedWidget;

//! @author Stefan Gehn
//! @brief widget that displays a list of pages on the left side and the
//! currently selected page on the right side
//!
class QTreeListWidget : public QWidget
{
Q_OBJECT

public:
	QTreeListWidget(QWidget *parent);

	//QFrame *addPage(const QStringList &tree, const QString &pageHeader, const QIcon &icon = QIcon());
	QFrame *addPage(const QString &pageName, const QString &pageHeader, const QIcon &icon = QIcon());
	void removePage(QFrame *page);

	void setCurrentPage(QFrame *page);
	QFrame *currentPage();

	virtual QSize minimumSizeHint() const;
	virtual QSize sizeHint() const;

private slots:
	void slotPageDestroyed(QObject *o);
	void slotTreeSelectionChanged();

private:
	QTreeWidget *mTree;
	QLabel *mTitle;
	QStackedWidget *mStack;
	QMap<QTreeWidgetItem *, int> mTreeItemToIndex;
	QMap<int, QString> mIndexToHeader;
};

#endif
